package caching.cache;

import java.io.Serializable;
import java.lang.reflect.Method;
import java.util.Arrays;

public class Invocation implements Serializable {
	private static final long serialVersionUID = 5918645201070717006L;
	private final Method method;
	private final Object[] objects;

	public Invocation(Method method, Object[] objects) {
		this.method = method;
		this.objects = objects;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((method == null) ? 0 : method.hashCode());
		result = prime * result + Arrays.hashCode(objects);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Invocation other = (Invocation) obj;
		if (method == null) {
			if (other.method != null)
				return false;
		} else if (!method.equals(other.method))
			return false;
		if (!Arrays.equals(objects, other.objects))
			return false;
		return true;
	}
}
