package caching.cache;

import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheManager;
import net.sf.ehcache.Element;
import net.sf.ehcache.config.CacheConfiguration;
import net.sf.ehcache.store.MemoryStoreEvictionPolicy;

public class InvocationCache {
	private static final MemoryStoreEvictionPolicy EVICTION_POLICY = MemoryStoreEvictionPolicy.LRU;
	private static final int CACHE_SIZE = 50;
	private static final InvocationCache instance = new InvocationCache();
	private Cache invocationCache;
	
	public static InvocationCache getInstance() {
		return instance;
	}
	private InvocationCache() {
		CacheManager singletonManager = CacheManager.create();
		invocationCache = new Cache(new CacheConfiguration("invocationCache", CACHE_SIZE).overflowToDisk(false).memoryStoreEvictionPolicy(EVICTION_POLICY));
		singletonManager.addCache(invocationCache);
	}
	public void put(Invocation invocation, Object result) {
		invocationCache.put(new Element(invocation, result));
	}
	public Object get(Invocation invocation) {
		Element element = invocationCache.get(invocation);
		return element != null ? element.getValue() : null;
	}

}
