package caching.dao;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class CallSimulator {

	private BufferedReader input;
	private final CustomerDao dao;

	public CallSimulator(File file, CustomerDao dao) throws FileNotFoundException {
		this.dao = dao;
		input = new BufferedReader(new FileReader(file));
	}
	public CallSimulator(File file) throws FileNotFoundException {
		this(file, null);
	}

	String readLine() throws IOException {
		return input.readLine(); 
	}

	String getUserFromLine(String logLine) {
		return logLine.substring(logLine.lastIndexOf('	')).trim();
	}

	long getTimeInMillisFromLine(String firstLineOfLog) throws Exception {
		String dateString = firstLineOfLog.substring(firstLineOfLog.lastIndexOf('*')+1, firstLineOfLog.indexOf(',') + 4).trim();
		SimpleDateFormat formatter = new SimpleDateFormat("dd-MM-yyHH:mm:ss,SSS");
		Date firstDate = formatter.parse(dateString);
		return firstDate.getTime();
	}

	public void playLog() throws Exception {
		String currentLine = "";
		while ((currentLine = readLine()) != null) {
			dao.findCustomerById(getUserFromLine(currentLine));
		}
	}
}
