package caching.logging;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;

public class InvocationLogger extends Observable {
	private ArrayList<InvocationLogEntry> entries;
	
	public static InvocationLogger getInstance() {
		return new InvocationLogger();
	}
	
	private InvocationLogger() {
		entries = new ArrayList<InvocationLogEntry>();
	}
	public void log(InvocationLogEntry entry) {
		entries.add(entry);
		setChanged();
		notifyObservers(entry);
		clearChanged();
	}
	public boolean contains(InvocationLogEntry entry) {
		return entries.contains(entry);
	}

	public int numberOfEntries() {
		return entries.size();
	}

	public Iterator<InvocationLogEntry> getIterator() {
		return entries.iterator();
	}

}
