package caching.dao;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNotSame;
import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

public class TestCustomer {
	private Customer customerA;
	private Customer customerAa;
	private Customer customerB;
	private Customer customerC;
	@Before
	public void setUp() {
		customerA = new Customer("a");
		customerAa = new Customer("a");
		customerB = new Customer("b");
		customerC = new Customer(null);
	}
	
	@Test
	public void knowsIfACustomerIsEqualToAnotherCustomer() {
		assertTrue( customerA.equals(customerA));
		assertTrue( customerA.equals(customerAa));
		assertTrue( customerAa.equals(customerA));
		assertFalse( customerA.equals(customerB));
		assertFalse( customerB.equals(customerA));
		assertFalse( customerA.equals(null));
		assertFalse( customerA.equals(""));
		assertFalse( customerC.equals(customerA));
	}

	@Test
	public void knowsAProperHashCode() {
		assertNotNull(customerA.hashCode());
		assertEquals( customerA.hashCode(), customerAa.hashCode());
		assertNotSame( customerA.hashCode(), customerB.hashCode());
		assertNotSame( customerC.hashCode(), customerA.hashCode());
	}

}
