package caching.logging;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class TestDuplicateInvocationReporter {
	
	@Test
	public void reportsDuplicateInvocationsWhenThresholdExceeded() {
		InvocationLogger logger = InvocationLogger.getInstance();
		DuplicateInvocationReporter observer = new DuplicateInvocationReporter(1);
		logger.addObserver(observer);
		InvocationLogEntry entry1 = InvocationLogEntry.createEntry("someinvocation", 1);
		InvocationLogEntry entry2 = InvocationLogEntry.createEntry("anotherentry", 1);
		logger.log(entry1);
		logger.log(entry2);
		assertFalse("Shouldnt be any dupilicated entries yet", observer.hasDuplicatedEntries());
		logger.log(entry1);
		assertTrue("Should have dupilicated entries now", observer.hasDuplicatedEntries());
		
	}
	
}
